↓ 跳过正文
  1. Posts/

hdu1069 Monkey and Banana (最长下降子序列)

·921 字·2 分钟

C - Monkey and Banana

**Time Limit:**1000MS **Memory Limit:**32768KB 64bit IO Format:%I64d & %I64u

Submit Status

Description

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height.

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn’t be stacked.

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.

Input

The input file will contain one or more test cases. The first line of each test case contains an integer n, representing the number of different blocks in the following data set. The maximum value for n is 30. Each of the next n lines contains three integers representing the values xi, yi and zi. Input is terminated by a value of zero (0) for n.

Output

For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format “Case case: maximum height = height”.

Sample Input

1 10 20 30 2 6 8 10 5 5 5 7 1 1 1 2 2 2 3 3 3 4 4 4 5 5 5 6 6 6 7 7 7 5 31 41 59 26 53 58 97 93 23 84 62 64 33 83 27 0

Sample Output

Case 1: maximum height = 40

Case 2: maximum height = 21

Case 3: maximum height = 28

Case 4: maximum height = 342

师傅给我准备的dp第二道。

dp比较渣,一开始看完题,看到有N种物品,每种无限个,加了些限制条件,感觉有点像完全背包。

不过那样想就完全歪掉了。

虽然说每种石块有无限个,但是由于条件限制…每种石块不可能取一个以上….

正解应该是先排序再做一个最长下降子序列

注意每个石块有6种不同的方法(有人说三种…不明白)在读入的时候处理一下即可。

看到有人按面积排序也可以AC,感觉不对,每个边的限制,按面积排序显然是放宽条件了。。。难道是因为数据水?

代码实现
 1
 2
 3
 4
 5
 6
 7    #include <iostream>
 8    #include <algorithm>
 9    #include <cstring>
10    #include <cstdio>
11    #include <cmath>
12
13    using namespace std;
14        int n,k,a,b,c,tmp;
15        const int N=1E4+5;
16        int dp[N];
17        long long ans;
18    struct Q
19    {
20        int x,y,z;
21
22    }q[N];
23
24    bool cmp(Q a,Q b)
25    {
26        if (a.x>b.x) return true;
27        if (a.x==b.x&&a.y>b.y) return true;
28        return false;
29    }
30
31    int main()
32    {
33        int cas=0;
34        while (scanf("%d",&n)!=EOF&&n)
35        {
36            cas++;
37            memset(dp,0,sizeof(dp));
38            k = 1;
39            ans = -1;
40            for ( int i = 1 ; i <= n ; i++ )
41            {
42                scanf("%d%d%d",&a,&b,&c);
43                q[k].x = a;q[k].y = b;q[k].z=c;k++;
44                q[k].x = a;q[k].y = c;q[k].z=b;k++;
45                q[k].x = b;q[k].y = a;q[k].z=c;k++;
46                q[k].x = b;q[k].y = c;q[k].z=a;k++;
47                q[k].x = c;q[k].y = a;q[k].z=b;k++;
48                q[k].x = c;q[k].y = b;q[k].z=a;k++;
49            }
50            k--;
51            sort(q+1,q+k+1,cmp);
52            dp[1]=q[1].z;
53
54            for ( int i = 2 ; i <= k ; i++ )
55            {
56                tmp = 0;
57                for ( int j = 1 ; j <= i-1 ; j++ )
58                    if (q[j].x>q[i].x&&q[j].y>q[i].y&&dp[j]>tmp)
59                    {
60                        tmp=dp[j];
61                    }
62                dp[i]=tmp+q[i].z;
63            }
64            for ( int i = 1 ; i <= k ; i++)
65                if ( dp[i]>ans )
66                    ans = dp[i];
67            printf("Case %d: maximum height = %I64d\n",cas,ans);
68        }
69        return 0;
70    }

相关文章

hdu 1171 Big Event in HDU (母函数,01背包)

·1075 字·3 分钟
**Time Limit: 10000/5000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 26534 Accepted Submission(s): 9332 ** Problem Description Nowadays, we all know that Computer College is the biggest department in HDU. But, maybe you don’t know that Computer College had ever been split into Computer College and Software College in 2002. The splitting is absolutely a big event in HDU! At the same time, it is a trouble thing too. All facilities must go halves. First, all facilities are assessed, and two facilities are thought to be same if they have the same value. It is assumed that there is N (0<N<1000) kinds of facilities (different value, different kinds).

hdu 1203 I NEED A OFFER! (01背包)

·977 字·2 分钟
I NEED A OFFER! # **Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 18287 Accepted Submission(s): 7320 ** Problem Description Speakless很早就想出国,现在他已经考完了所有需要的考试,准备了所有要准备的材料,于是,便需要去申请学校了。要申请国外的任何大学,你都要交纳一定的申请费用,这可是很惊人的。Speakless没有多少钱,总共只攒了n万美元。他将在m个学校中选择若干的(当然要在他的经济承受范围内)。每个学校都有不同的申请费用a(万美元),并且Speakless估计了他得到这个学校offer的可能性b。不同学校之间是否得到offer不会互相影响。“I NEED A OFFER”,他大叫一声。帮帮这个可怜的人吧,帮助他计算一下,他可以收到至少一份offer的最大概率。(如果Speakless选择了多个学校,得到任意一个学校的offer都可以)。

hdu 2546 饭卡 (01背包)

·692 字·2 分钟
饭卡 # **Time Limit: 5000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 14225 Accepted Submission(s): 4945 ** Problem Description 电子科大本部食堂的饭卡有一种很诡异的设计,即在购买之前判断余额。如果购买一个商品之前,卡上的剩余金额大于或等于5元,就一定可以购买成功(即使购买后卡上余额为负),否则无法购买(即使金额足够)。所以大家都希望尽量使卡上的余额最少。 某天,食堂中有n种菜出售,每种菜可购买一次。已知每种菜的价格以及卡上的余额,问最少可使卡上的余额为多少。

hdu 5119 - Happy Matt Friends(dp解法)

·820 字·2 分钟
Description Matt has N friends. They are playing a game together. Each of Matt’s friends has a magic number. In the game, Matt selects some (could be zero) of his friends. If the xor (exclusive-or) sum of the selected friends’magic numbers is no less than M , Matt wins. Matt wants to know the number of ways to win. Input The first line contains only one integer T , which indicates the number of test cases.

HDOJ 4882 Loves Codefires

·589 字·2 分钟
ZCC Loves Codefires Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 988 Accepted Submission(s): 500 Problem Description Though ZCC has many Fans, ZCC himself is a crazy Fan of a coder, called “Memset137”. It was on Codefires(CF), an online competitive programming site, that ZCC knew Memset137, and immediately became his fan. But why? Because Memset137 can solve all problem in rounds, without unsuccessful submissions; his estimation of time to solve certain problem is so accurate, that he can surely get an Accepted the second he has predicted. He soon became IGM, the best title of Codefires. Besides, he is famous for his coding speed and the achievement in the field of Data Structures. After become IGM, Memset137 has a new goal: He wants his score in CF rounds to be as large as possible. What is score? In Codefires, every problem has 2 attributes, let’s call them Ki and Bi(Ki, Bi>0). if Memset137 solves the problem at Ti-th second, he gained Bi-KiTi score. It’s guaranteed Bi-KiTi is always positive during the round time. Now that Memset137 can solve every problem, in this problem, Bi is of no concern. Please write a program to calculate the minimal score he will lose.(that is, the sum of Ki*Ti).